<template>
<div v-if="this.$store.getters.authenticatedUser">
    <b-container>
      <b-modal ref="my-modal" hide-footer title="Confirmation message">
      <div class="d-block text-center">
        <h6>New deployment has been added!</h6>
      </div>
      <div> <b-row>
        <b-col cols="4"></b-col>
        <b-col cols="4">
          <router-link :to="{name:'deployments'}"> 
          <b-button class="mt-3" variant="success" block >Ok</b-button>
          </router-link>
        </b-col>
      <b-col cols="4"></b-col>
      </b-row>
      </div>
    </b-modal>
    <b-modal ref="failure-modal" hide-footer title="Creation failed">
      <div class="d-block text-center">
        <h6>This deployment cannot be created because another deployment with the exact same name already exists. Please, use another name.</h6>
      </div>
      <div> <b-row>
        <b-col cols="4"></b-col>
        <b-col cols="4">          
          <b-button class="mt-3" variant="warning" block @click="hideModal" >Ok</b-button>          
        </b-col>
      <b-col cols="4"></b-col>
      </b-row>
      </div>
    </b-modal>
<br>
<br>
<br>

  <b-card id="addCard" bg-variant="light">
       <b-row rows="2"  > <p style=" color: #22b574 ; font-size: 200%">
            New CATALYST Marketplace deployment
            </p>
        </b-row>
        <b-row>
          <b-col>
            <b-form-group
        label-cols-sm="3"
        label="Name:"
        label-align-sm="right"
        label-for="nested-name"
      >
        <b-form-input id="nested-name"
            v-model = "name"
        ></b-form-input>
        <b-alert dismissible style="width: 100%" v-model="emptyNameAlert" variant="warning">
                  You have to provide a name!
                </b-alert>
      </b-form-group>
      </b-col>
      <b-col>
      </b-col>
        </b-row>
        <b-row>
          <b-col>
      <b-form-group
        label-cols-sm="3"
        label="Type:"
        label-align-sm="right"
        label-for="nested-type"
      >
        <b-form-select id="nested-type"
        :options="FlavourOptions"
        v-model.number = "flavour"
        ></b-form-select>
        <b-alert dismissible style="width: 100%" v-model="emptyFlavourAlert" variant="warning">
                  You have to provide a type!
                </b-alert>
      </b-form-group>
      </b-col>
      <b-col>
      <b-form-group
        label-cols-sm="3"
        label="Clearing:"
        label-align-sm="right"
        label-for="nested-state"
      >
        <b-form-select id="nested-state"
        :options="ClearingOptions"
        v-model.number = "clearing"
        type="number"></b-form-select>
        <b-alert dismissible style="width: 100%" v-model="emptyClearingAlert" variant="warning">
                  You have to provide a clearing!
                </b-alert>
      </b-form-group>
      </b-col>
</b-row>
<hr>
<b-row>
  <b-col>
       <b-form-group
        label-cols-sm="3"
        label="Country:"
        label-align-sm="right"
        label-for="nested-country"
      >
        <b-form-select
        :options="CountryOptions"
        @change="CountryChange"

        v-model = "country"

        id="nested-operator"></b-form-select>
        <b-alert dismissible style="width: 100%" v-model="emptyCountryAlert" variant="warning">
                  You have to provide a country!
                </b-alert>
      </b-form-group>
      </b-col>
<b-col>

  <b-form-group
        label-cols-sm="3"
        label="Region:"
        label-align-sm="right"
        label-for="nested-region"
      >
        <b-form-select
        :options="RegionOptions"
        @change="RegionChange"
        v-model = "region"

        id="nested-region"></b-form-select>
        <b-alert dismissible style="width: 100%" v-model="emptyRegionAlert" variant="warning">
                  You have to provide a region!
                </b-alert>
      </b-form-group></b-col>
</b-row>
<b-row>
  <b-col>
       <b-form-group
        label-cols-sm="3"
        label="City:"
        label-align-sm="right"
        label-for="nested-city"
      >
        <b-form-select
        :options="CityOptions"

        v-model = "city"

        id="nested-city"></b-form-select>
        <b-alert dismissible style="width: 100%" v-model="emptyCityAlert" variant="warning">
                  You have to provide a city!
                </b-alert>
      </b-form-group>

      </b-col>
<b-col>
<!--
  <b-form-group
        label-cols-sm="3"
        label="Zip Code:"
        label-align-sm="right"
        label-for="nested-zip_code"
      >
       <b-form-input id="nested-zip_code"
            v-model = "zip_code"
        ></b-form-input>
      </b-form-group> -->
      </b-col>
</b-row>
<hr>

<b-row>

<b-col>
<b-form-group
        label-cols-sm="3"
        label="Operator:"
        label-align-sm="right"
        label-for="nested-operator"
      >
        <b-form-select
        :options="OperatorOptions"

        v-model.number = "operator"

        id="nested-operator"></b-form-select>
        <b-alert dismissible style="width: 100%" v-model="emptyOperatorAlert" variant="warning">
                  You have to provide an operator!
                </b-alert>
      </b-form-group>

</b-col>
<b-col>
<div  id="SaveButtonRow" @click="checkForm"  @mouseover="SavemouseOver"  @mouseleave="SavemouseOut">
 <img v-if="HoverSave"
 width="10%" src= "../assets/SaveButtonAtHover.png" >
  <img v-if="OutOfSave"
 width="10%" src= "../assets/SaveButton.png" >
 </div>
</b-col>
</b-row>
<!--       </b-row> -->
  </b-card>
    </b-container>
</div>
<div v-else>
  <NoAccess></NoAccess>
  </div>
</template>
<script>
// import axios from 'axios'
import MaaSaxios from '../axios/index'
import state from '../store/state'
import NoAccess from '../components/NoAccess.vue'
import {mapGetters} from 'vuex'

export default {
  computed: {
    ...mapGetters([
      'authenticatedUser'
    ])
  },
  data () {
    return {
      boxOne: '',
      emptyNameAlert: false,
      emptyClearingAlert: false,
      emptyFlavourAlert: false,
      emptyOperatorAlert: false,
      emptyCountryAlert: false,
      emptyRegionAlert: false,
      emptyCityAlert: false,
      type: '',
      typeOfClearing: '',
      name: '',
      country: '',
      city: '',
      zip_code: '',
      region: '',
      regionNr: '',
      url: '',
      api_url: '',
      HoverSave: false,
      OutOfSave: true,
      operational: true,
      flavour: null,
      clearing: null,
      operator: '',
      request: 1,
      StatusOptions: [
        { text: 'Pending', value: 1 },
        { text: 'Active', value: 2 },
        { text: 'Inactive', value: 3 }
      ],
      ClearingOptions: [
        { text: 'Market', value: 1 },
        { text: 'Selective', value: 2 },
        { text: 'Best-fit', value: 3 }
      ],
      FlavourOptions: [],
      CountryOptions: [],
      RegionOptions: [],
      CityOptions: [],
      Zip_CodeOptions: [],
      OperatorOptions: [
        { text: 'electricity', value: 1 },
        { text: 'flexibility', value: 2 },
        { text: 'heat', value: 3 },
        { text: 'it-load', value: 4 }
      ]
    }
  },
  components: {NoAccess},
  beforeCreate () {
    console.log(this.$store.getters.authenticatedUser)
    if (this.$store.getters.authenticatedUser === false) {
      this.$router.push({name: 'home'})
    }

  },

  created () {
    console.log(345)
    console.log(this.$store.getters.authenticatedUser)

    MaaSaxios.get('/flavours/?page=1', {headers: {
      'Authorization': 'Bearer ' + state.user.access_token
    }})
      .then(response => {
        console.log(response.data.results)
        let fetchedFlavours = response.data.results
        let newFlavours = []
        var i
        for (i = 0; i < fetchedFlavours.length; i++) {
          newFlavours.push({
            text: fetchedFlavours[i].type,
            value: fetchedFlavours[i].id
          })
        }
        this.FlavourOptions = newFlavours
        console.log(this.FlavourOptions)
      })

    MaaSaxios.get('/regions/countries/', {headers: {
      'Authorization': 'Bearer ' + state.user.access_token
    }})
      .then(response => {
        console.log(response.data)
        let fetchedCountries = response.data
        let newCountries = []
        var i
        for (i = 0; i < fetchedCountries.length; i++) {
          newCountries.push({
            text: fetchedCountries[i].country,
            value: fetchedCountries[i].country
          })
        }
        this.CountryOptions = newCountries
        console.log(this.CountryOptions)
      })
      .catch((error) => {
        console.info(error)
      })

    MaaSaxios.get('/operators/?page=1', {headers: {
      'Authorization': 'Bearer ' + state.user.access_token
    }})
      .then(response => {
        console.log(response.data.results)
        let fetchedOperators = response.data.results
        let newOperators = []
        var i
        for (i = 0; i < fetchedOperators.length; i++) {
          newOperators.push({
            text: fetchedOperators[i].name + ' (' + fetchedOperators[i].username + ')',
            value: fetchedOperators[i].id
          })
        }
        this.OperatorOptions = newOperators
        console.log(this.OperatorOptions)
      })
    MaaSaxios.get('clearing_mechanisms/?page=1', {headers: {
      'Authorization': 'Bearer ' + state.user.access_token
    }})
      .then(response => {
        console.log(response.data.results)
        let fetchedClearingMechanisms = response.data.results
        let newClearingMechanisms = []
        var i
        for (i = 0; i < fetchedClearingMechanisms.length; i++) {
          newClearingMechanisms.push({
            text: fetchedClearingMechanisms[i].type,
            value: fetchedClearingMechanisms[i].id
          })
        }
        this.ClearingOptions = newClearingMechanisms
        console.log(this.ClearingOptions)
      })
  },
  methods: {
    CountryChange () {
      this.FetchRegions()
      this.city = ''
    },
    RegionChange () {
      this.FetchCity()
    },
    FetchRegions () {
      MaaSaxios.get('/regions/countries/' + this.country + '/regions/', {headers: {
        'Authorization': 'Bearer ' + state.user.access_token
      }})
        .then(response => {
          console.log('3789')
          console.log(response.data)
          console.log('8766')
          let fetchedRegions = response.data
          let newRegions = []
          var i
          for (i = 0; i < fetchedRegions.length; i++) {
            newRegions.push({
              text: fetchedRegions[i].region,
              value: fetchedRegions[i].region
            })
          }
          this.RegionOptions = newRegions
          console.log(this.RegionOptions)
        })
        .catch((error) => {
          console.info(error)
        })
    },
    FetchCity () {
      MaaSaxios.get('/regions/countries/' + this.country + '/regions/' + this.region + '/cities/', {headers: {
        'Authorization': 'Bearer ' + state.user.access_token
      }})
        .then(response => {
          console.log('3789')
          console.log(response.data)
          console.log('8766')
          let fetchedCities = response.data
          let newCities = []
          var i
          for (i = 0; i < fetchedCities.length; i++) {
            newCities.push({
              text: fetchedCities[i].city,
              value: fetchedCities[i].city
            })
          }
          this.CityOptions = newCities
          console.log(this.CityOptions)
        })
        .catch((error) => {
          console.info(error)
        })
    },
    checkForm () {
      // check if all required fields are filled
        if (!this.name) {
          this.emptyNameAlert = true
        }
        else if (!this.flavour) {
          this.emptyFlavourAlert = true
        }
        else if (!this.clearing) {
          this.emptyClearingAlert = true
        }
        else if (!this.country) {
          this.emptyCountryAlert = true
        }
        else if (!this.region) {
          this.emptyRegionAlert = true
        }
        else if (!this.city) {
          this.emptyCityAlert = true
        }
        else if (!this.operator) {
          this.emptyOperatorAlert = true
        }
       else {
        this.CreateDeployment()
       }
    },
    CreateDeployment () {
      MaaSaxios.get('/regions/repr/' + this.country + '/' + this.region + '/' + this.city + '/', {headers: {
        'Authorization': 'Bearer ' + state.user.access_token
      }})
        .then(response => {
          this.regionNr = response.data.id
          console.log('this.regionNr')
          console.log(this.regionNr)
          console.log(parseInt(this.regionNr))

          let DataToBeSent = []
          DataToBeSent = {
          //   type : this.type ,
            name: this.name,
            status: 'pending',
            operational: true,
            flavour: this.flavour,
            clearing: this.clearing,
            region: this.regionNr,
            operator: this.operator
            //     status: 1,
            //   operational: null,
            //     request: this.request
          }
          console.log(DataToBeSent)
          this.$store.dispatch('createDeployment', DataToBeSent)
          .then(
            response => {
                console.log(response)
          if(response.status) {
            if (response.status = '200'){ this.$refs['my-modal'].show()}
            } 
          else if (response.response.status = '409')
         {this.$refs['failure-modal'].show()}

            }
          )            
        })
    },
    hideModal() {
         this.$refs['failure-modal'].hide()
      },
    SavemouseOver () {
      this.HoverSave = true
      this.OutOfSave = false
      console.log('sdfdsfd')
    },
    SavemouseOut () {
      this.HoverSave = false
      this.OutOfSave = true
      console.log('44444444')
    }}
}
</script>

<style scoped>

#addCard {
  border : 0px
}
#SaveButtonRow {
  text-align : right;
   cursor: pointer;
}
</style>
